%% Ploting of main text
%% Fig 2 a-b Import
addpath("...\Scripts "); % !!!!! The address where the script is located !!!!
addpath("...\Scripts\cbrewer"); %!!!!! The address where the script is located !!!!
%Data file location
File='...\164922_d01_IthStab_Iheat0.10mA_vgate0V_2.00_to_15.00K.dat'; %!!!!! The address where the data is located !!!!
Dat =importdata(File);
T=unique(Dat.data(:,12));
Bias=unique(Dat.data(:,4));
dIdV_temp=Dat.data(:,9);
Ith_temp=Dat.data(:,6);
dIdV=reshape(dIdV_temp,length(Bias),length(T));
Ith=reshape(Ith_temp,length(Bias),length(T));
%% a) Temperature dependence of dI/dV
dIdV_smooth=smoothdata(dIdV,'gaussian',12);

figure;
cmap=colormap(viridis);
color=round(linspace(1,floor(length(cmap)),length(T)));
COLOR=cmap(color,:);

hold on;
sep=floor(length(T)/5);
for i=1:length(T)
    if mod(i,sep)==1
    plot(Bias,dIdV_smooth(:,i),'Color',COLOR(i,:),'DisplayName',[num2str(T(i),"%2.2f") ' K']);
    end
end
box on
set(gca,'xlim',[-19,19])
xlabel ('V_{sd} (mV)')
ylabel ('dI/dV (\muS)')
legend
%% b) Fit the spin 1/2 Kondo empirical model
guess=[0,6];
peak_error=zeros(1,length(T));
Peakloc=zeros(1,length(T));
peakheight_1=zeros(1,length(T));
peakwidth=zeros(1,length(T));
for i=1:length(T)
%peakfit(signal,center,window,NumPeaks,peakshape,extra,NumTrials,start,autozero,fixedparameters,plots,bipolar,minwidth,DELTA,clipheight)
[FitResults, FitError, Baseline]=peakfit([Bias dIdV_smooth(:,i)],0,35,1,2,0,5,guess,1,0,0,0);
%FitResults ->  PeakNumber  Position   Height     Width      PeakArea
temp=6+i*0.1;
guess=[0,temp];

peakheight_1(i)=FitResults(3);
Peakloc(i)=FitResults(2);
peak_error(i)=FitError(2);
peakwidth(i)=FitResults(4);
end
%CREATEFIT(X_FIT,PEAKHEIGHT_1)
%  Create a fit.
%  Data for 'untitled fit 1' fit:
%      X Input : x_fit
%      Y Output: peakheight_1
%  Output:
%      fitresult : a fit object representing the fit.
%      gof : structure with goodness-of fit info.
%
%  See also FIT, CFIT, SFIT.
%  Auto-generated by MATLAB on 20-May-2020 14:00:22
[xData, yData] = prepareCurveData( T, peakheight_1 );

% Set up fittype and options.
ft = fittype( 'G1*((x^2/Tk^2) *(2^(1/0.22)-1)+1)^(-0.22)+Gc', 'independent', 'x', 'dependent', 'y' );
opts = fitoptions( 'Method', 'NonlinearLeastSquares' );
opts.Display = 'Off';
opts.Lower = [-Inf -Inf 0];
opts.StartPoint = [0.432319187349009 0.689734061017163 0.5066];
% Fit model to data.
[fitresult, gof] = fit( xData, yData, ft, opts );
% Plot fit with data.
err_temp=confint(fitresult,0.95);
err_Tk=diff(err_temp(:,3))/2;
figure;
plot(fitresult);
% legend( h, 'peakheight_1 vs. x_fit', 'untitled fit 1', 'Location', 'NorthEast' );
% Label axes
hold on 
scatter(T,peakheight_1)
set(gca,'xscale','log')
xlabel('T (K)')
ylabel('G (\muS) ')
xline(fitresult.Tk,'--');
legend('fitted curve','data',['T_K=' num2str(fitresult.Tk,'%2.2f') '\pm' num2str(err_Tk,'%1.1f') 'K' ],'location','best')
%% Fig 2 c-d Import
%Data file location
File='...\115913_d01_IthMag_Iheat0.10mA.dat';%!!!!! The address where the data is located !!!!
Dat =importdata(File);
B=flip(unique(Dat.data(:,3)));
Bias=unique(Dat.data(:,4));
dIdV_temp=Dat.data(:,9);
Ith_temp=Dat.data(:,6);
dIdV=reshape(dIdV_temp,length(Bias),length(B));
Ith=reshape(Ith_temp,length(Bias),length(B));
%% c)
dIdV_smooth=smoothdata(dIdV,'gaussian',12);
figure;
colormap(magma);
imagesc(B,Bias,dIdV_smooth);
set(gca,'YDir','normal');
colorbar
xlabel('B (T)')
ylabel('V_{sd} (mV)')
%% d)
figure;
hold on;
cmap=flip(colormap(viridis));
color=round(linspace(1,floor(length(cmap)),length(B)));
COLOR=cmap(color,:);
sep=ceil(length(B)/5);
for i=1:length(B)
    if mod(i,sep)==1
    plot(Bias,dIdV_smooth(:,i),'Color',COLOR(i,:),'DisplayName',[num2str(B(i)) 'T']);
    end
end
box on
set(gca,'xlim',[-19,19])
xlabel ('V_{sd} (mV)')
ylabel ('dI/dV (\muS)')
legend
%% Fig 3 a-b Import
% Import
File='...\115913_d01_IthMag_Iheat0.10mA.dat'; %!!!!! The address where the data is located !!!!
Dat =importdata(File);
B=flip(unique(Dat.data(:,3)));
Bias=unique(Dat.data(:,4));
dIdV_temp=Dat.data(:,9);
Ith_temp=Dat.data(:,6);
dIdV=reshape(dIdV_temp,length(Bias),length(B));
Ith=reshape(Ith_temp,length(Bias),length(B));
%% a)
Ith_smooth=smoothdata(Ith,'gaussian',12);
figure;
cmap=flip(cbrewer('div','RdBu',length(B)*3));
colormap(cmap);
imagesc(B,Bias,Ith_smooth*2*sqrt(2));
set(gca,'YDir','normal');
h = colorbar;
ylabel(h, 'I_{th} (nA)')
lim=max(max(Ith_smooth*2*sqrt(2)));
set(h,'ylim',[-1*lim ,lim])
xlabel('B (T)')
ylabel('V_{sd} (mV)')
%% b)
figure;
hold on;
cmap=flip(colormap(viridis));
color=round(linspace(1,floor(length(cmap)),length(B)));
COLOR=cmap(color,:);
sep=ceil(length(B)/5);
for i=1:length(B)
    if mod(i,sep)==1
    plot(Bias,Ith_smooth(:,i)*2*sqrt(2),'Color',COLOR(i,:),'DisplayName',[num2str(B(i)) 'T']);
    end
end
box on
set(gca,'xlim',[-19,19])
xlabel ('V_{sd} (mV)')
ylabel ('Ith (nA)')
legend
%% Fig 4 Get the slope of Ith around Vsd=0
%Take +- 1mV as the window for the slope differentiation 
Vmin_loc=find(Bias>-1,1,'first');
Vmax_loc=find(Bias<1,1,'last');
slope=zeros(length(B),2);
error=zeros(length(B),1);
Bias_range=Bias(Vmin_loc:Vmax_loc)*1e-3;
Ith_smooth_range=zeros(length(Bias_range),length(B));
for i=1: length(B)
Ith_smooth_range(:,i)=Ith(Vmin_loc:Vmax_loc,i)*2*sqrt(2)*1e-9;
end
figure
hold on
for i=1:length(B)
    slope(i,1)=B(i);
    [cf,gof ]= fit(Bias_range,Ith_smooth_range(:,i),'poly1');
    slope(i,2)=cf.p1;
    err_temp=confint(cf,0.68);% 1 sigma
    error(i)=(err_temp(2,1)-err_temp(1,1))/2;
end
scatter(slope(:,1),slope(:,2)) 
errorbar(slope(:,1),slope(:,2),error)
box on
ylabel('dI_{th}/dV (A/mV)')
xlabel('B field (T)')